// ddを配列にする
var dd = new Array();

//=========================
// サンプル
//=========================
//-------------------------
// BASIC
//-------------------------
var ahe = 'あへあへうひは';

dd[0] = {
  content: [
    { text: ahe }, //'First paragraph',
    'Another paragraph, this time a little bit longer to make sure, this line will be divided into at least two lines'
  ]
};

//-------------------------
// STYLES1
//-------------------------
dd[1] = {
  content: [
    {
      text: 'ヘッダー',
      style: 'header'
    },
    'ヘッダーの文章日本語\n\n',
    {
      text: 'ヘッダー―1',
      style: 'subheader'
    },
    'aヘッダー1の文章その1',
    'bヘッダー1の文章その2',
    'cヘッダー1の文章その3\n\n',
    {
      text: 'ヘッダー―2',
      style: 'subheader'
    },
    'aヘッダー2の文章その1Windows',
    'bヘッダー2の文章その2',
    'cヘッダー2の文章その3\n\n',
    {
      text: ['注釈', 'abcうんたらかんたらほげほげ！＠＃＄％＾＆＊（）＿＋”｜｝｛？＞＜わ'],
      style: ['quote', 'small']
    }
  ],
  
  styles: {
    header: {
      fontSize: 18,
      bold: true
    },
    
    subheader: {
      fontSize: 15,
      bold: true
    },
    
    quote: {
      italics: true
    },
    
    small: {
      fontSize: 8
    }
  }
};

//-------------------------
// STYLES2
//-------------------------
dd[2] = {
  content: [
    {
      text: 'へっだー\n\n',
      style: 'header'
    },
    {
      text: [
        '1行目だべ',
        'の途中で',
        { text: 'フォントサイズ', fontSize: 15, bole: true },
        'が変わるはず。\nそして、',
        { text: 'さらに', italics: true, fontSize: 20 },
        { text: 'さらに倍', italics: true, fontSize: 40 },
        'でおわり\n\n'
      ]
    },
    {
      style: 'bigger',
      italics: false,
      text: [
        'aaaaaaaaaaaaaaaa aaaaa aaaabbbbbbbbbbbbbbbbbbbbbbbbbbccccccccccccccccccccccccccdddddddddddddddddddd',
        'また、段落とイン ラインレベル の両方で名前付きスタイルとスタイルの上書きを混在させることができます。',
        'たとえば、この段落は15にのfontSizeを変更し、trueに斜体を設定し、「大きな」スタイルを、使用しています。',
        'テキストは、しかし斜体されていません。　私たちは、段落レベルでバックfalseにオーバーライドされたイタリック体をしたからです。\n\n',
        '我々はまた、1つのインラインのスタイルを変更することができます。指定したスタイルと呼ばれるヘッダを使用してみましょう。:',
        { text: 'ここのように\n', style: 'header' },
        'それは大きく、大胆です。\n\n',
        'OK 今、私たちは、インラインレベルでの名前付きスタイルとスタイル・オーバーライドをミックスしようとしています。',
        '我々は（それがテキスト大きく、太字になります）ヘッダーのスタイルを使用しますが、',
        '我々はすごいfalseに戻って大胆オーバーライドします！',
        { text: ' できます！', style: 'header', bold: false },
        '\n\nここで何が起こっているのかを理解するために情報源に見てみるようにしてください。'
      ]
    }
  ],
  
  styles: {
    header: {
      fontSize: 18,
      bold: true
    },
    bigger: {
      fontSize: 15,
      italics: true
    }
  }
};

//-------------------------
// STYLES3
//-------------------------
dd[3] = {
  content: [
    {
      text: 'センターそろえええ',
      style: 'header',
      alignment: 'center'
    },
    {
      text: [
        'テキストその1\n',
        'This paragraph uses header style and overrides bold value setting it back to false.\n',
        'Header style in this example sets alignment to justify, so this paragraph should be rendered \n',
        'Lorem ipsum dolor sit amet, consectetur adipisicing elit. Malit profecta versatur nomine ocurreret multavit, officiis viveremus aeternum superstitio suspicor alia nostram, quando nostros congressus susceperant concederetur leguntur iam, vigiliae democritea tantopere causae, atilii plerumque ipsas potitur pertineant multis rem quaeri pro, legendum didicisse credere ex maluisset per videtis. Cur discordans praetereat aliae ruinae dirigentur orestem eodem, praetermittenda divinum. Collegisti, deteriora malint loquuntur officii cotidie finitas referri doleamus ambigua acute. Adhaesiones ratione beate arbitraretur detractis perdiscere, constituant hostis polyaeno. Diu concederetur.'
      ],
      style: 'header',
      bold: false
    }
  ],
  
  styles: {
    header: {
      fontSize: 18,
      bold: true,
      alignment: 'justify'
    }
  }
};

//-------------------------
// COLUMNS
//-------------------------
dd[4] = {
  content: [
    '別 - デフォルトでは、段落は、（以下または実際に）の上に積み重ねています。',
    'しかし列に任意の段落（あるいは文書全体）を分割することが可能です。',
    'ここでは、20に設定揃えテキストとのギャップで、2つ星のサイズの列に行きます:\n\n',
    {
      columnGap: 20,  //defaultStyleが効かないので此処で定義した
      fontSize: 10,
      alignment: 'justify',
      columns: [
        {
          //text: 'Lorem ipsum dolor sit amet, consectetur adipisicing elit. Malit profecta versatur nomine ocurreret multavit, officiis viveremus aeternum superstitio suspicor alia nostram, quando nostros congressus susceperant concederetur leguntur iam, vigiliae democritea tantopere causae, atilii plerumque ipsas potitur pertineant multis rem quaeri pro, legendum didicisse credere ex maluisset per videtis. Cur discordans praetereat aliae ruinae dirigentur orestem eodem, praetermittenda divinum. Collegisti, deteriora malint loquuntur officii cotidie finitas referri doleamus ambigua acute. Adhaesiones ratione beate arbitraretur detractis perdiscere, constituant hostis polyaeno. Diu concederetur.'
          text: '段落（だんらく、希: παράγραφος、\n独: Paragraf、\n仏: paragraphe、\n英: paragraph）とは、\n文章において見やすくまとめ\nられた文の塊\n（ブロック）。\n通常は複数の文\nによって構成される。'
        },
        {
          text: 'Lorem ipsum dolor sit amet, consectetur adipisicing elit. Malit profecta versatur nomine ocurreret multavit, officiis viveremus aeternum superstitio suspicor alia nostram, quando nostros congressus susceperant concederetur leguntur iam, vigiliae democritea tantopere causae, atilii plerumque ipsas potitur pertineant multis rem quaeri pro, legendum didicisse credere ex maluisset per videtis. Cur discordans praetereat aliae ruinae dirigentur orestem eodem, praetermittenda divinum. Collegisti, deteriora malint loquuntur officii cotidie finitas referri doleamus ambigua acute. Adhaesiones ratione beate arbitraretur detractis perdiscere, constituant hostis polyaeno. Diu concederetur.'
          //text: '段落の始めは、行頭から数文字（日本語では1文字）の字下げをする。日本語の縦書きでは行頭が下がるので、「段落」という言葉が生まれた。パラグラフともいう。'
        }
      ]
    },
    '\nスターサイズのカラムは、常に同じ幅を有しているので、我々はそれらの3を定義した場合、\nそれは（私たちはより多くの例のカップルを持っているとして、次のページにスクロールしてください）このようになります：\n\n',
    {
      columns: [
        {
          text: 'Lorem ipsum dolor sit amet, consectetur adipisicing elit. Malit profecta versatur nomine ocurreret multavit, officiis viveremus aeternum superstitio suspicor alia nostram, quando nostros congressus susceperant concederetur leguntur iam, vigiliae democritea tantopere causae, atilii plerumque ipsas potitur pertineant multis rem quaeri pro, legendum didicisse credere ex maluisset per videtis. Cur discordans praetereat aliae ruinae dirigentur orestem eodem, praetermittenda divinum. Collegisti, deteriora malint loquuntur officii cotidie finitas referri doleamus ambigua acute. Adhaesiones ratione beate arbitraretur detractis perdiscere, constituant hostis polyaeno. Diu concederetur.'
        },
        {
          text: 'Lorem ipsum dolor sit amet, consectetur adipisicing elit. Malit profecta versatur nomine ocurreret multavit, officiis viveremus aeternum superstitio suspicor alia nostram, quando nostros congressus susceperant concederetur leguntur iam, vigiliae democritea tantopere causae, atilii plerumque ipsas potitur pertineant multis rem quaeri pro, legendum didicisse credere ex maluisset per videtis. Cur discordans praetereat aliae ruinae dirigentur orestem eodem, praetermittenda divinum. Collegisti, deteriora malint loquuntur officii cotidie finitas referri doleamus ambigua acute. Adhaesiones ratione beate arbitraretur detractis perdiscere, constituant hostis polyaeno. Diu concederetur.'
        },
        {
          text: 'Lorem ipsum dolor sit amet, consectetur adipisicing elit. Malit profecta versatur nomine ocurreret multavit, officiis viveremus aeternum superstitio suspicor alia nostram, quando nostros congressus susceperant concederetur leguntur iam, vigiliae democritea tantopere causae, atilii plerumque ipsas potitur pertineant multis rem quaeri pro, legendum didicisse credere ex maluisset per videtis. Cur discordans praetereat aliae ruinae dirigentur orestem eodem, praetermittenda divinum. Collegisti, deteriora malint loquuntur officii cotidie finitas referri doleamus ambigua acute. Adhaesiones ratione beate arbitraretur detractis perdiscere, constituant hostis polyaeno. Diu concederetur.'
        }
      ]
    },
    
    /*
    '\n\nああ、私たちはここにもスタイリング例至るまで\n（という名前のスタイル、カスタムの上書き）を使用することができ、\n忘れてはいけません。',
    '例えば - 「大きな」スタイルを使用します。\n私たちの次の段落（ - 真のfontSizeでは15とイタリックに設定しました）。\n我々は3つの列に分割し、彼らはスタイルを継承することを確認します。',
    {
      style: 'bigger',
      columns: [
        '
    }
    */
    
    '\nまた、正確ないくつかのための幅（またはすべての列）を指定することができます。\nそれでは、最初の列と狭い最後の1を作成し、\n他の星の列の間に均等にレイアウトエンジン除算残りのスペースをさせてみましょう。\n\n',
    {
      columns: [
        {
          width: 90,
          text: 'Lorem ipsum dolor sit amet, consectetur adipisicing elit. Malit profecta versatur nomine ocurreret multavit, officiis viveremus aeternum superstitio suspicor alia nostram, quando nostros congressus susceperant concederetur leguntur iam, vigiliae democritea tantopere causae, atilii plerumque ipsas potitur pertineant multis rem quaeri pro, legendum didicisse credere ex maluisset per videtis. Cur discordans praetereat aliae ruinae dirigentur orestem eodem, praetermittenda divinum. Collegisti, deteriora malint loquuntur officii cotidie finitas referri doleamus ambigua acute. Adhaesiones ratione beate arbitraretur detractis perdiscere, constituant hostis polyaeno. Diu concederetur.'
        },
        {
          width: '*',
          text: 'Lorem ipsum dolor sit amet, consectetur adipisicing elit. Malit profecta versatur nomine ocurreret multavit, officiis viveremus aeternum superstitio suspicor alia nostram, quando nostros congressus susceperant concederetur leguntur iam, vigiliae democritea tantopere causae, atilii plerumque ipsas potitur pertineant multis rem quaeri pro, legendum didicisse credere ex maluisset per videtis. Cur discordans praetereat aliae ruinae dirigentur orestem eodem, praetermittenda divinum. Collegisti, deteriora malint loquuntur officii cotidie finitas referri doleamus ambigua acute. Adhaesiones ratione beate arbitraretur detractis perdiscere, constituant hostis polyaeno. Diu concederetur.'
        },
        {
          width: '*',
          text: 'Lorem ipsum dolor sit amet, consectetur adipisicing elit. Malit profecta versatur nomine ocurreret multavit, officiis viveremus aeternum superstitio suspicor alia nostram, quando nostros congressus susceperant concederetur leguntur iam, vigiliae democritea tantopere causae, atilii plerumque ipsas potitur pertineant multis rem quaeri pro, legendum didicisse credere ex maluisset per videtis. Cur discordans praetereat aliae ruinae dirigentur orestem eodem, praetermittenda divinum. Collegisti, deteriora malint loquuntur officii cotidie finitas referri doleamus ambigua acute. Adhaesiones ratione beate arbitraretur detractis perdiscere, constituant hostis polyaeno. Diu concederetur.'
        },
        {
          width: 90,
          text: 'Lorem ipsum dolor sit amet, consectetur adipisicing elit. Malit profecta versatur nomine ocurreret multavit, officiis viveremus aeternum superstitio suspicor alia nostram, quando nostros congressus susceperant concederetur leguntur iam, vigiliae democritea tantopere causae, atilii plerumque ipsas potitur pertineant multis rem quaeri pro, legendum didicisse credere ex maluisset per videtis. Cur discordans praetereat aliae ruinae dirigentur orestem eodem, praetermittenda divinum. Collegisti, deteriora malint loquuntur officii cotidie finitas referri doleamus ambigua acute. Adhaesiones ratione beate arbitraretur detractis perdiscere, constituant hostis polyaeno. Diu concederetur.'
        }
      ]
    },
    
    '\nまた、自動列をサポート。\n彼らはコンテンツに基づいてそれらの幅を設定します。\n\n',
    {
      columns: [
        {
          width: 'auto',
          text: 'auto column'
        },
        {
          width: '*',
          text: 'This is a star-sized column. It should get the remaining space divided by the number of all star-sized columns.'
        },
        {
          width: 50,
          text: 'this one has specific width set to 50'
        },
        {
          width: 'auto',
          text: 'another auto column'
        },
        {
          width: '*',
          text: 'This is a star-sized column. It should get the remaining space divided by the number of all star-sized columns.'
        },
      ]
    },
    
    '\nすべての自動の列が利用可能な幅に収まる場合は、\n表全体のスペースを占有しません。\n\n',
    {
      columns: [
        {
          width: 'auto',
          text: 'val1'
        },
        {
          width: 'auto',
          text: 'val2'
        },
        {
          width: 'auto',
          text: 'value3'
        },
        {
          width: 'auto',
          text: 'value 4'
        },
      ]    
    },
    
    '\npdfmakeのもう一つのクールな機能は、ネストされた要素を持っている能力です。\n各列は、実際に文書全体に非常に似ているので、\n我々は次の例のように、内側の段落し、\nさらに部門を持つことができます。\n\n',
    {
      columns: [
        {
          width: 100,
          fontSize: 9,
          text: 'Lorem ipsum dolor sit amet, consectetur adipisicing elit. Conveniunt quieti extremum severitatem disseretur virtute locum virtus declarant. Greges telos detrimenti persius possint eripuit appellat democrito suscipere existimant. Facere usus levitatibus confirmavit, provincia rutilius libris accommodare valetudinis ignota fugienda arbitramur falsarum commodius. Voluptas summis arbitrarer cognitio temperantiamque, fuit posidonium pro assueverit animos inferiorem, affecti honestum ferreum cum tot nemo ius partes dissensio opinor, tuum intellegunt numeris ignorant, odia diligenter licet, sublatum repellere, maior ficta severa quantum mortem. Aut evertitur impediri vivamus.'
        },
        [
          'あなたはドキュメント定義に見ることができるように\n - この列はオブジェクトで定義されたが、\nそれは段落の配列として扱われます意味配列は、\n別の下の1をレンダリングされません。',
          'ただ、文書のトップレベルに好きです。 \n3つ星のサイズの列にremaing空間を\n分割してみましょう。\n\n',
          {
            columns: [
              { text: 'Lorem ipsum dolor sit amet, consectetur adipisicing elit. Malit profecta versatur nomine ocurreret multavit, officiis viveremus aeternum superstitio suspicor alia nostram, quando nostros congressus susceperant concederetur leguntur iam, vigiliae democritea tantopere causae, atilii plerumque ipsas potitur pertineant multis rem quaeri pro, legendum didicisse credere ex maluisset per videtis. Cur discordans praetereat aliae ruinae dirigentur orestem eodem, praetermittenda divinum. Collegisti, deteriora malint loquuntur officii cotidie finitas referri doleamus ambigua acute. Adhaesiones ratione beate arbitraretur detractis perdiscere, constituant hostis polyaeno. Diu concederetur.' },
              { text: 'Lorem ipsum dolor sit amet, consectetur adipisicing elit. Malit profecta versatur nomine ocurreret multavit, officiis viveremus aeternum superstitio suspicor alia nostram, quando nostros congressus susceperant concederetur leguntur iam, vigiliae democritea tantopere causae, atilii plerumque ipsas potitur pertineant multis rem quaeri pro, legendum didicisse credere ex maluisset per videtis. Cur discordans praetereat aliae ruinae dirigentur orestem eodem, praetermittenda divinum. Collegisti, deteriora malint loquuntur officii cotidie finitas referri doleamus ambigua acute. Adhaesiones ratione beate arbitraretur detractis perdiscere, constituant hostis polyaeno. Diu concederetur.' },
              { text: 'Lorem ipsum dolor sit amet, consectetur adipisicing elit. Malit profecta versatur nomine ocurreret multavit, officiis viveremus aeternum superstitio suspicor alia nostram, quando nostros congressus susceperant concederetur leguntur iam, vigiliae democritea tantopere causae, atilii plerumque ipsas potitur pertineant multis rem quaeri pro, legendum didicisse credere ex maluisset per videtis. Cur discordans praetereat aliae ruinae dirigentur orestem eodem, praetermittenda divinum. Collegisti, deteriora malint loquuntur officii cotidie finitas referri doleamus ambigua acute. Adhaesiones ratione beate arbitraretur detractis perdiscere, constituant hostis polyaeno. Diu concederetur.' },
            ]
          }
        ]
      ]
    },
    
    '\n\nああ、私たちはここにもスタイリング例至るまで\n（という名前のスタイル、カスタムの上書き）を使用することができ、\n忘れてはいけません。\n\n',
    '例えば - 「大きな」スタイルを使用します。\n私たちの次の段落（ - 真のfontSizeでは15とイタリックに設定しました）。\n我々は3つの列に分割し、彼らはスタイルを継承することを確認します。\n\n',
    {
      style: 'bigger',
      columns: [
        'First column (BTW - it\'s defined as a single string value. pdfmake will turn it into appropriate structure automatically and make sure it inherits the styles',
        {
          fontSize: 20,
          text: 'In this column, we\'ve overriden fontSize to 20. It means the content should have italics=true (inherited from the style) and be a little bit bigger',
        },
        {
          style: 'header',
          text: 'Last column does not override any styling properties, but applies a new style (header) to itself. Eventually - texts here have italics=true (from bigger) and derive fontSize from the style. OK, but which one? Both styles define it. As we already know from our styling examples, multiple styles can be applied to the element and their order is important. Because \'header\' style has been set after \'bigger\' its fontSize takes precedence over the fontSize from \'bigger\'. This is how it works. You will find more examples in the unit tests.'
        }
      ]
    },
    '\n\nうわー、あなたは文書全体を読みました！おめでとうございます：D'
  ],
  styles: {
    header: {
      fontSize: 18,
      bold: false
    },
    bigger: {
      fontSize: 15,
      italics: false
    }
  },
  defaultStyle: {
    columnGap: 20,
  }

};

//-------------------------
// TABLES
//-------------------------
dd[5] = {
  content: [
    { text: 'Tables', style: 'header' },
    '公式ドキュメントは、このドキュメントは\npdfmakeとそのレイアウトエンジンで何かを\n可能にするだけ垣間見るある、進行中です。',
    { text: '簡単な表（無ヘッダー、指定されていない幅、\nノースパン、ノースタイリング）', style: 'subheader' },
    '次の表は、ボディ・アレイよりも何もしています',
    {
      style: 'tableExample',
      table: {
        body: [
          ['Column1', 'Column2', 'Column3'],
          ['一つの値がここに入ります', 'ここでもう1', 'OK?'],
        ],
      }
    },
    
    { text: 'ネストされた要素を持つ単純なテーブル', style: 'subheader' },
    'それは巣にもちろん、\nテーブルセルの内部pdfmakeで利用可能な\nノードの任意の他のタイプが可能です',
    {
      style: 'tableExample',
      table: {
        body: [
          ['Column1', 'Column2', 'Column3', 'C4'],
          [
            {
              stack: [
                'それでは、\n順不同リストを試してみましょう',
                {
                  ul: [
                    'item 1',
                    'item 2'
                  ]
                }
              ]
            },
            [
              'またはネストした表',
              {
                table: {
                  body: [
                    [ 'Col1', 'Col2', 'Col3' ],
                    [ '1', '2', '3'],
                    [ '1', '2', '3']
                  ]
                }
              }
            ],
            {
              text: [
                'インライン化を\nすることができます',
                { text: 'styled\n', fontSize: 4 },
                { text: 'easily as everywhere else', fontSize: 8 }
              ]
            },
            'もいっこ'
          ]
        ]
      }
    },
    
    { text: '列の幅を定義します', style: 'subheader' },
    '表には、標準の列と同じ幅の定義をサポートしています。',
    {
      ul: [
        'auto',
        'star',
        'fixed value(固定値)'
      ]
    },
    {
      style: 'tableExample',
      table: {
        widths: [100, '*', 200, '*'],
        body: [
          [ 'width=100', 'star-sized', 'width=200', 'star-sized'],
          [ 
            '固定幅の\nセルが指定\nされた\n正確な\n幅を持って\nいます',
            { text: 'nothing interesting here', italics: false, color: 'gray' }, 
            { text: 'nothing interesting here', italics: false, color: 'gray' }, 
            { text: 'nothing interesting here', italics: false, color: 'gray' }
          ]
        ]
      }
    },
    
    { text: 'ヘッダ', style: 'subheader' },
    'あなたは、ヘッダーとして扱われるべき行数を宣言することができます。\n',
    'ヘッダには、自動的に次のページに繰り返しています。',
    { text: [
        'ヘッダと、これらの行の間に改ページが\n',
        '存在しないであろうことを確認するkeepWithHeaderRowsを\n',
        '設定することも可能です。文書定義を見て、それで遊びます。\n',
        'あなたは1に設定した場合、最初の行は、ここで描画するための\n',
        '十分なスペースがありませんので、以下の表は、\n',
        '自動的に、次のページで開始されます。',
        'ページが変われは、ヘッダーが付く',
        '\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n'
      ],
      color: 'gray',
      italics: false
    },
    {
      style: 'tableExample',
      table: {
        headerRows: 1,
        // keepWithHeaderRows: 1,
        // dontBreakRows: true,    
        body: [
          [ 
            { text: 'Header 1', style: 'tableHeader' },
            { text: 'Header 2', style: 'tableHeader' },
            { text: 'Header 3', style: 'tableHeader' }
          ],
          [
            'Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua. Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris nisi ut aliquip ex ea commodo consequat. Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu fugiat nulla pariatur. Excepteur sint occaecat cupidatat non proident, sunt in culpa qui officia deserunt mollit anim id est laborum.', 
            'Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua. Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris nisi ut aliquip ex ea commodo consequat. Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu fugiat nulla pariatur. Excepteur sint occaecat cupidatat non proident, sunt in culpa qui officia deserunt mollit anim id est laborum.', 
            'Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua. Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris nisi ut aliquip ex ea commodo consequat. Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu fugiat nulla pariatur. Excepteur sint occaecat cupidatat non proident, sunt in culpa qui officia deserunt mollit anim id est laborum.'
          ]
        ]
      }
    },
    
    { text: '列/行スパン', style: 'subheader' },
    '各セルの要素は、ROWSPANとCOLSPANを設定することができます',
    {
      style: 'tableExample',
      color: '#444',
      table: {
        widths: [200, 'auto', 'auto' ],
        headerRows: 2,
        body: [
          // 1行目のヘッダー
          [
            { 
              text: 'Header width Colspan = 2', 
              style: 'tableHeader', 
              colSpan: 2, 
              alignment: 'center'
            },
            {}, // 2列目（1列目と合体しているので定義なし）
            {
              text: 'Header 3',
              style: 'tableHeader',
              alignment: 'center'
            }
          ],
          
          // 2行目ヘッダー
          [
            { text: 'Header 1', style: 'tableHeader', alignment: 'center' },
            { text: 'Header 2', style: 'tableHeader', alignment: 'center' },
            { text: 'Header 3', style: 'tableHeader', alignment: 'center' }
          ],
          
          // 3行目
          [ 'Sample value 1', 'Sample value 2', 'Sample value 3' ],
          
          // 4行目（rowSpan）
          [
            {
              text: 'rowSpan set to 3\nLorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor',
              rowSpan: 3
            },
            'Sample value 2',
            'Sample value 3'
          ],
          
          // 5行目（4行目のrowSpanにかかっているので1列目は空白にする。）
          [ '', 'Sample value 2', 'Sample value 3' ],
          
          // 6行目（4行目のrowSpanにかかっているが、1列目も値を入れてみる。）
          [ 'Sample value 1', 'Sample value 2', 'Sample value 3' ],
          
          // 7行目（rowSpanとcolSpan両方）
          [ 
            'Sample value 1',
            {
              text: 'Both:\nrowSpan and colSpan\ncan be defined at the same time',
              colSpan: 2,
              rowSpan: 2
            },
            ''  // colSpanにかかるので空白
          ],
          
          // 8行目（rowSapnとcolSapnにかかるので、2列目、3列目は空白）
          [ 'Sample value 1', '', '' ]
        ]
      }
    },
    
    { text: 'Styling tables', style: 'subheader' },
    'あなたは、テーブル用のカスタムスタイルを\n提供することができます。現在はサポートしています。',
    {
      ul: [
        'line widths',
        'line colors',
        'cell paddings'
      ]
    },
    'より多くのオプションがすぐに来ると...\n\n',
    'pdfmakeは現在、いくつかの定義済みのスタイルを\n（次のページにそれらを参照してください）持っています',
    
    {
      text: 'ボーダー無し',
      fontSize: 14,
      bold: false,
      pageBreak: 'before',
      margin: [0, 0, 0, 8] // 左、上、右、下
    },
    {
      style: 'tableExample',
      table: {
        headerRows: 1,
        body: [
          [
            { text: 'Header 1', style: 'tableHeader' },
            { text: 'Header 2', style: 'tableHeader' },
            { text: 'Header 3', style: 'tableHeader' }
          ],
          [ 'Sample value 1', 'Sample value 2', 'Sample value 3' ],
          [ 'Sample value 1', 'Sample value 2', 'Sample value 3' ],
          [ 'Sample value 1', 'Sample value 2', 'Sample value 3' ],
          [ 'Sample value 1', 'Sample value 2', 'Sample value 3' ],
          [ ahe /*'Sample value 1'*/, 'Sample value 2', 'Sample value 3' ]
        ]
      },
      layout: 'noBorders'
    },
    
    { text: 'ヘッダーラインのみ', fontSize: 14, bold: false, margin: [0, 20, 0, 8] },
    {
      style: 'tableExample',
      table: {
        headerRows: 1,
        body: [
          [
            { text: 'Header 1', style: 'tableHeader' }, 
            { text: 'Header 2', style: 'tableHeader'}, 
            { text: 'Header 3', style: 'tableHeader' }
          ],
          [ 'Sample value 1', 'Sample value 2', 'Sample value 3' ],
          [ 'Sample value 1', 'Sample value 2', 'Sample value 3' ],
          [ 'Sample value 1', 'Sample value 2', 'Sample value 3' ],
          [ 'Sample value 1', 'Sample value 2', 'Sample value 3' ],
          [ 'Sample value 1', 'Sample value 2', 'Sample value 3' ],
        ]
      },
      layout: 'headerLineOnly'
    },
    
    { text: '水平ライン', fontSize: 14, bold: true, margin: [0, 20, 0, 8] },
    {
        style: 'tableExample',
        table: {
            headerRows: 1,
            body: [
              [
                { text: 'Header 1', style: 'tableHeader' }, 
                { text: 'Header 2', style: 'tableHeader'}, 
                { text: 'Header 3', style: 'tableHeader' }
              ],
              [ 'Sample value 1', 'Sample value 2', 'Sample value 3' ],
              [ 'Sample value 1', 'Sample value 2', 'Sample value 3' ],
              [ 'Sample value 1', 'Sample value 2', 'Sample value 3' ],
              [ 'Sample value 1', 'Sample value 2', 'Sample value 3' ],
              [ 'Sample value 1', 'Sample value 2', 'Sample value 3' ],
            ]
        },
        layout: 'lightHorizontalLines'
    },
    
    { text: 'しかし、あなたにも、\nカスタムスタイラーを提供することができます', margin: [0, 20, 0, 8] },
    {
      style: 'tableExample',
      table: {
        headerRows: 1,
        body: [
          [
            { text: 'Header 1', style: 'tableHeader' }, 
            { text: 'Header 2', style: 'tableHeader'}, 
            { text: 'Header 3', style: 'tableHeader' }
          ],
          [ 'Sample value 1', 'Sample value 2', 'Sample value 3' ],
          [ 'Sample value 1', 'Sample value 2', 'Sample value 3' ],
          [ 'Sample value 1', 'Sample value 2', 'Sample value 3' ],
          [ 'Sample value 1', 'Sample value 2', 'Sample value 3' ],
          [ 'Sample value 1', 'Sample value 2', 'Sample value 3' ],
        ]
      },
      layout: {
        hLineWidth: function(i, node) {
          return (i === 0 || i === node.table.body.length) ? 2 : 1;
        },
        vLineWidth: function(i, node) {
            return (i === 0 || i === node.table.widths.length) ? 2 : 1;
        },
        hLineColor: function(i, node) {
            return (i === 0 || i === node.table.body.length) ? 'black' : 'gray';
        },
        vLineColor: function(i, node) {
            return (i === 0 || i === node.table.widths.length) ? 'black' : 'gray';
        },
        // paddingLeft: function(i, node) { return 4; },
        // paddingRight: function(i, node) { return 4; },
        // paddingTop: function(i, node) { return 2; },
        // paddingBottom: function(i, node) { return 2; }
      }
    }
  ],
  
  styles: {
    header: {
      fontSize: 18,
      bold: false,
      margin: [0, 0, 0, 10]
    },
    subheader: {
      fontSize: 16,
      bold: false,
      margin: [0, 10, 0, 5]
    },
    tableExample: {
      margin: [0, 5, 0, 15]
    },
    tableHeader: {
      bold: false,
      fontSize: 13,
      color: 'black'
    }
  }
};








//-------------------------
// ボタンクリックイベント
// 配列番号を引数に対応するサンプルを開く
// ddをdd[no]に変更
//-------------------------
function pdfOpen(no) {
  
  // フォント
  pdfMake.fonts = {
    GenShin: {
      normal:      'GenShinGothic-Normal-Sub.ttf',
      bold:        'GenShinGothic-Normal-Sub.ttf',
      italics:     'GenShinGothic-Normal-Sub.ttf',
      bolditalics: 'GenShinGothic-Normal-Sub.ttf'
    }
  }
  
  if (!dd[no]['defaultStyle']) {
    dd[no]['defaultStyle'] = new Object();
  }
  dd[no]['defaultStyle']['font'] = 'GenShin';
  
  // ブラウザ名を取得
  var name = getBrowser();
  
  // ブラウザことに処理を分岐
  // IEの場合
  if (name == 'ie') {
    pdfMake.createPdf(dd[no]).download('optionalName.pdf');
  
  // IE以外
  } else {
    pdfMake.createPdf(dd[no]).open();
  }
}

//-------------------------
// ブラウザを判定する関数
//-------------------------
var getBrowser = function() {
  
  var name = 'unknown';
  
  // ユーザーエージェントを取得
  var ua = window.navigator.userAgent.toLowerCase();
  
  // ieをチェック
  if (ua.indexOf("msie") != -1 ||
      ua.indexOf('edge') != -1 ||
      ua.indexOf('trident/7') != -1) {
    name = 'ie';
  
  // ie以外
  } else if (ua.indexOf('chrome') != -1) {
    name = 'chrome';
    
  } else if (ua.indexOf('safari') != -1) {
    name = 'safari';
    
  } else if (ua.indexOf('opera') != -1) {
    name = 'opera';
    
  } else if (ua.indexOf('firefox') != -1) {
        name = 'firefox';
  }
  
  return name;
}

